// student CRUD

#include <stdio.h>
#define MAX_CLASS_SIZE 50

int load_data( char [][25], int [], int [], int [] );
void display_students( int, char [][25], int [], int [], int [] );

int main( void ) {
  char names[MAX_CLASS_SIZE][25];
  int exam1[MAX_CLASS_SIZE];
  int exam2[MAX_CLASS_SIZE];
  int exam3[MAX_CLASS_SIZE];

  //load the student data
  int loaded_students = load_data( names, exam1, exam2, exam3 );
  if( loaded_students == -1 ) {
    printf("The students.txt data file could not be found\n");
    return 1;
  }

  //display all students
  display_students( loaded_students, names, exam1, exam2, exam3 );

  return 0;
} //end main

//load the student data from file
int load_data( char names[][25], int e1[], int e2[], int e3[] ) {
  FILE * data_file = fopen("students.txt", "r");
  if(! data_file) {
    return -1;
  }

  int student_count = 0;
  while( fscanf(data_file, "%25[^,],%d,%d,%d\n", names[student_count], &e1[student_count], &e2[student_count], &e3[student_count]) == 4 ) {
    student_count++;
  }

  return student_count;
}

//display the student data from arrays
void display_students( int max, char names[][25], int e1[], int e2[], int e3[] ) {
  //display column headers
  printf("%-25s%10s%10s%10s\n\n", "Name", "Exam1", "Exam2", "Exam3");

  //display student data
  for(int x = 0 ; x < max ; x++) {
    printf("%-25s", names[x]); //left justified student name
    printf("%10d", e1[x]);
    printf("%10d", e2[x]);
    printf("%10d\n", e3[x]);
  }
}
